/*
 * Copyright (C) 2016 Laboratoire ThéMA - UMR 6049 - CNRS / Université de Franche-Comté
 * http://thema.univ-fcomte.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.thema.lucsim.gui.generator.dt;

import java.awt.BorderLayout;
import java.awt.Cursor;
import java.util.ArrayList;
import java.util.List;
import javax.swing.JDialog;
import javax.swing.JFrame;
import org.thema.lucsim.generator.dt.BatchClassifierRunnable;
import org.thema.lucsim.generator.dt.TreeBinaryClassifier;
import org.thema.lucsim.generator.dt.IncrementalClassifierRunnable;
import org.thema.lucsim.gui.LucsimView;
import org.thema.lucsim.gui.stat.DataExtractorPanel;
import org.thema.lucsim.stat.DataExtractor;
import org.thema.lucsim.stat.FileDataExtractor;

/**
 * Window dialog which prompts the user for the parameters to use to build the
 * dataset used to train the tree.
 * This data set can either be imported or created. If it is created, said user 
 * is able to choose the following options (default values are bracketed):<br>
 * - the first Layer, used to fetch land use data (first layer of the list of
 *   layers the project contains);<br>
 * - the second Layer, used to note if a cell issued from the former layer faced
 *   a transition towards the target state (second layer of the list of layers 
 *   the project contains);<br>
 * - the target state (first state the first layer contains);<br>
 * - if the project contains addtional layers, which ones shall be taken into 
 *   account;<br>
 * - the neighborhood function to use, and wether to use it plain or in rings 
 *   (plain nbCellSq);<br>
 * - the start radius, used to determine the minimal distance between the
 *   current cell under calculation and the cells taken into consideration
 *   (1);<br>
 * - the end radius, used to determine the maximal distance between the current
 *   cell under calculation and the cells taken into consideration (10);<br>
 * - the step to use to grow the neighborhood size (1).
 */
public class DecisionTreeDialog extends JDialog {

    private TreeBinaryClassifier classifier;
    private List<Double> params = new ArrayList<>();
    
    private JDialog dataDlg;
    private DataExtractorPanel dataPanel;
    
    private LucsimView lucsimView;

    /**
     * Constructs a DecisionTreeDialog, using the specified Project to retrieve
     * its layers.
     *
     * @param parent JDialog's parent frame (for location purposes)
     * @param lucsimView current view and project (to retrieve project-related data such as
     * layers)
     */
    public DecisionTreeDialog(JFrame parent, LucsimView lucsimView) {
        super(parent,false);
        initComponents();
        setLocationRelativeTo(parent);
        this.lucsimView = lucsimView;
        
        dataDlg = new JDialog(this, "Data extraction", true);
        dataPanel = new DataExtractorPanel(lucsimView.getProject());
        dataDlg.getContentPane().setLayout(new BorderLayout());
        dataDlg.getContentPane().add(dataPanel, BorderLayout.CENTER);
        dataDlg.pack();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        bindingGroup = new org.jdesktop.beansbinding.BindingGroup();

        buttonGroup1 = new javax.swing.ButtonGroup();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(32767, 0));
        panelBackground = new javax.swing.JPanel();
        buttonStart = new javax.swing.JButton();
        buttonClose = new javax.swing.JButton();
        panelClassifier = new javax.swing.JPanel();
        labelClassifierTitle = new javax.swing.JLabel();
        labelClassifier = new javax.swing.JLabel();
        comboBoxClassifier = new javax.swing.JComboBox<>();
        labelProgressState1 = new javax.swing.JLabel();
        buttonSettingsTree = new javax.swing.JButton();
        labelTrainingRation = new javax.swing.JLabel();
        spinnerRatio = new javax.swing.JSpinner();
        label100 = new javax.swing.JLabel();
        randomCheckBox = new javax.swing.JCheckBox();
        panelImportDataset = new javax.swing.JPanel();
        labelImportDatasetTitle = new javax.swing.JLabel();
        labelProgressState3 = new javax.swing.JLabel();
        selectFilePanelImportDataset = new org.thema.common.swing.SelectFilePanel();
        importRadioButton = new javax.swing.JRadioButton();
        createRadioButton = new javax.swing.JRadioButton();
        paramDatasetButton = new javax.swing.JButton();
        progressBar = new org.thema.common.swing.ProgressBarPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Decision tree dialog");
        setBackground(new java.awt.Color(185, 185, 185));

        filler1.setName("filler1"); // NOI18N

        panelBackground.setName("panelBackground"); // NOI18N

        buttonStart.setText("Start");
        buttonStart.setPreferredSize(new java.awt.Dimension(73, 23));
        buttonStart.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonStartActionPerformed(evt);
            }
        });

        buttonClose.setText("Close");
        buttonClose.setPreferredSize(new java.awt.Dimension(73, 23));
        buttonClose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonCloseActionPerformed(evt);
            }
        });

        panelClassifier.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        panelClassifier.setName("panelClassifier"); // NOI18N
        panelClassifier.setPreferredSize(new java.awt.Dimension(200, 150));

        labelClassifierTitle.setFont(new java.awt.Font("Arial", 1, 18)); // NOI18N
        labelClassifierTitle.setText("Classifier");
        labelClassifierTitle.setName("labelClassifierTitle"); // NOI18N

        labelClassifier.setText("Classifier              :");
        labelClassifier.setName("labelClassifier"); // NOI18N

        comboBoxClassifier.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "J48 Tree", "Hoeffding Tree" }));
        comboBoxClassifier.setToolTipText("");
        comboBoxClassifier.setName("comboBoxClassifier"); // NOI18N
        comboBoxClassifier.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                comboBoxClassifierActionPerformed(evt);
            }
        });

        labelProgressState1.setName("labelProgressState1"); // NOI18N

        buttonSettingsTree.setText("Advanced classifier settings");
        buttonSettingsTree.setBorder(null);
        buttonSettingsTree.setName("buttonSettingsTree"); // NOI18N
        buttonSettingsTree.setPreferredSize(new java.awt.Dimension(73, 23));
        buttonSettingsTree.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonSettingsTreeActionPerformed(evt);
            }
        });

        labelTrainingRation.setText("Training ratio        :");
        labelTrainingRation.setName("labelTrainingRation"); // NOI18N

        spinnerRatio.setModel(new javax.swing.SpinnerNumberModel(75, 1, 100, 1));
        spinnerRatio.setName("spinnerRatio"); // NOI18N

        label100.setText("/ 100");
        label100.setName("label100"); // NOI18N

        randomCheckBox.setText("Randomize");
        randomCheckBox.setName("randomCheckBox"); // NOI18N

        javax.swing.GroupLayout panelClassifierLayout = new javax.swing.GroupLayout(panelClassifier);
        panelClassifier.setLayout(panelClassifierLayout);
        panelClassifierLayout.setHorizontalGroup(
            panelClassifierLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelClassifierLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(panelClassifierLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, panelClassifierLayout.createSequentialGroup()
                        .addComponent(labelClassifierTitle)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(labelProgressState1))
                    .addGroup(panelClassifierLayout.createSequentialGroup()
                        .addComponent(labelClassifier)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(panelClassifierLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(buttonSettingsTree, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(comboBoxClassifier, 0, 256, Short.MAX_VALUE)))
                    .addGroup(panelClassifierLayout.createSequentialGroup()
                        .addGroup(panelClassifierLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(panelClassifierLayout.createSequentialGroup()
                                .addComponent(labelTrainingRation)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(spinnerRatio, javax.swing.GroupLayout.PREFERRED_SIZE, 56, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(label100))
                            .addComponent(randomCheckBox))
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        panelClassifierLayout.setVerticalGroup(
            panelClassifierLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelClassifierLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(panelClassifierLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(labelProgressState1)
                    .addGroup(panelClassifierLayout.createSequentialGroup()
                        .addComponent(labelClassifierTitle)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(panelClassifierLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(labelClassifier)
                            .addComponent(comboBoxClassifier, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(buttonSettingsTree, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(panelClassifierLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelTrainingRation)
                    .addComponent(spinnerRatio, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(label100))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(randomCheckBox)
                .addContainerGap(40, Short.MAX_VALUE))
        );

        panelImportDataset.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        panelImportDataset.setName("panelImportDataset"); // NOI18N
        panelImportDataset.setPreferredSize(new java.awt.Dimension(200, 150));

        labelImportDatasetTitle.setFont(new java.awt.Font("Arial", 1, 18)); // NOI18N
        labelImportDatasetTitle.setText("Dataset");
        labelImportDatasetTitle.setName("labelImportDatasetTitle"); // NOI18N

        labelProgressState3.setName("labelProgressState3"); // NOI18N

        selectFilePanelImportDataset.setDescription("Input file");
        selectFilePanelImportDataset.setFileDesc("CSV file");
        selectFilePanelImportDataset.setFileExts(".csv");
        selectFilePanelImportDataset.setName("selectFilePanelImportDataset"); // NOI18N

        org.jdesktop.beansbinding.Binding binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, importRadioButton, org.jdesktop.beansbinding.ELProperty.create("${selected}"), selectFilePanelImportDataset, org.jdesktop.beansbinding.BeanProperty.create("enabled"));
        bindingGroup.addBinding(binding);

        buttonGroup1.add(importRadioButton);
        importRadioButton.setText("Import");
        importRadioButton.setName("importRadioButton"); // NOI18N

        buttonGroup1.add(createRadioButton);
        createRadioButton.setSelected(true);
        createRadioButton.setText("Create");
        createRadioButton.setName("createRadioButton"); // NOI18N

        paramDatasetButton.setText("Set parameters");
        paramDatasetButton.setName("paramDatasetButton"); // NOI18N

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, createRadioButton, org.jdesktop.beansbinding.ELProperty.create("${selected}"), paramDatasetButton, org.jdesktop.beansbinding.BeanProperty.create("enabled"));
        bindingGroup.addBinding(binding);

        paramDatasetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                paramDatasetButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout panelImportDatasetLayout = new javax.swing.GroupLayout(panelImportDataset);
        panelImportDataset.setLayout(panelImportDatasetLayout);
        panelImportDatasetLayout.setHorizontalGroup(
            panelImportDatasetLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelImportDatasetLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(panelImportDatasetLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(panelImportDatasetLayout.createSequentialGroup()
                        .addComponent(labelImportDatasetTitle)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(labelProgressState3))
                    .addGroup(panelImportDatasetLayout.createSequentialGroup()
                        .addGap(12, 12, 12)
                        .addComponent(selectFilePanelImportDataset, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE))
                    .addGroup(panelImportDatasetLayout.createSequentialGroup()
                        .addGroup(panelImportDatasetLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(importRadioButton)
                            .addGroup(panelImportDatasetLayout.createSequentialGroup()
                                .addComponent(createRadioButton)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(paramDatasetButton)))
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        panelImportDatasetLayout.setVerticalGroup(
            panelImportDatasetLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelImportDatasetLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(panelImportDatasetLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(labelProgressState3)
                    .addComponent(labelImportDatasetTitle))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(importRadioButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(selectFilePanelImportDataset, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(panelImportDatasetLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(createRadioButton)
                    .addComponent(paramDatasetButton))
                .addContainerGap(29, Short.MAX_VALUE))
        );

        progressBar.setName("progressBar"); // NOI18N

        javax.swing.GroupLayout panelBackgroundLayout = new javax.swing.GroupLayout(panelBackground);
        panelBackground.setLayout(panelBackgroundLayout);
        panelBackgroundLayout.setHorizontalGroup(
            panelBackgroundLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelBackgroundLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(panelBackgroundLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(panelBackgroundLayout.createSequentialGroup()
                        .addComponent(buttonClose, javax.swing.GroupLayout.PREFERRED_SIZE, 79, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(progressBar, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(buttonStart, javax.swing.GroupLayout.PREFERRED_SIZE, 79, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(panelClassifier, javax.swing.GroupLayout.DEFAULT_SIZE, 403, Short.MAX_VALUE)
                    .addComponent(panelImportDataset, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 403, Short.MAX_VALUE))
                .addContainerGap())
        );
        panelBackgroundLayout.setVerticalGroup(
            panelBackgroundLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelBackgroundLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(panelClassifier, javax.swing.GroupLayout.DEFAULT_SIZE, 202, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(panelImportDataset, javax.swing.GroupLayout.PREFERRED_SIZE, 171, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(panelBackgroundLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(buttonClose, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(buttonStart, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(progressBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap(427, Short.MAX_VALUE)
                .addComponent(filler1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addComponent(panelBackground, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(filler1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(432, Short.MAX_VALUE))
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addComponent(panelBackground, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        bindingGroup.bind();

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void buttonSettingsTreeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonSettingsTreeActionPerformed
        if (((String) comboBoxClassifier.getSelectedItem()).equals("J48 Tree")) {
            J48TreeSettingsDialog j48sd = new J48TreeSettingsDialog(this, params);
            j48sd.setVisible(true);    
        } else {
            HoeffdingTreeSettingsDialog dtsd = new HoeffdingTreeSettingsDialog(this, params);
            dtsd.setVisible(true);
        }
    }//GEN-LAST:event_buttonSettingsTreeActionPerformed

    private void buttonCloseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonCloseActionPerformed
        setVisible(false);
        dispose();
    }//GEN-LAST:event_buttonCloseActionPerformed

    private void buttonStartActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonStartActionPerformed
       
        DataExtractor extractor;
        if(importRadioButton.isSelected()) {
            extractor = new FileDataExtractor(selectFilePanelImportDataset.getSelectedFile(), lucsimView.getProject());
        } else {
            extractor = dataPanel.getDataExtractor();
        }
        
        String classifierName = (String) comboBoxClassifier.getSelectedItem();
        if(classifierName.equals("J48 Tree")) {
            classifier = new BatchClassifierRunnable(
                extractor,
                ((Number)spinnerRatio.getValue()).doubleValue() / 100,
                params,
                progressBar,
                randomCheckBox.isSelected() ? (int)System.currentTimeMillis() : 1);
        } else if (classifierName.equals("Hoeffding Tree")) {
            classifier = new IncrementalClassifierRunnable(
                    extractor,
                    params,
                    progressBar);
        }
        setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        buttonStart.setEnabled(false);
            
        new Thread(() -> {
            try {
                classifier.run();
            } catch (Exception ex) {
                throw new RuntimeException(ex);
            } finally {
                buttonStart.setEnabled(true);
                setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
            }
            PostProcessDialog postProcessDialog = new PostProcessDialog(DecisionTreeDialog.this, classifier, lucsimView);
            postProcessDialog.setVisible(true);
        }).start();
        
    }//GEN-LAST:event_buttonStartActionPerformed

    private void comboBoxClassifierActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_comboBoxClassifierActionPerformed
        if (((String) comboBoxClassifier.getSelectedItem()).equals("J48 Tree")) {
            spinnerRatio.setEnabled(true);
            label100.setEnabled(true);
            randomCheckBox.setEnabled(true);
        } else {
            spinnerRatio.setEnabled(false);
            label100.setEnabled(false);
            randomCheckBox.setEnabled(false);
        }
    }//GEN-LAST:event_comboBoxClassifierActionPerformed

    private void paramDatasetButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_paramDatasetButtonActionPerformed
        dataDlg.setVisible(true);
    }//GEN-LAST:event_paramDatasetButtonActionPerformed
                

    /**
     * Returns the classifier created by the dialog, depending on the options the 
     * user chose.
     * @return classifier created by the dialog
     */
    public TreeBinaryClassifier getClassifier() {
        return classifier;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton buttonClose;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton buttonSettingsTree;
    private javax.swing.JButton buttonStart;
    private javax.swing.JComboBox<String> comboBoxClassifier;
    private javax.swing.JRadioButton createRadioButton;
    private javax.swing.Box.Filler filler1;
    private javax.swing.JRadioButton importRadioButton;
    private javax.swing.JLabel label100;
    private javax.swing.JLabel labelClassifier;
    private javax.swing.JLabel labelClassifierTitle;
    private javax.swing.JLabel labelImportDatasetTitle;
    private javax.swing.JLabel labelProgressState1;
    private javax.swing.JLabel labelProgressState3;
    private javax.swing.JLabel labelTrainingRation;
    private javax.swing.JPanel panelBackground;
    private javax.swing.JPanel panelClassifier;
    private javax.swing.JPanel panelImportDataset;
    private javax.swing.JButton paramDatasetButton;
    private org.thema.common.swing.ProgressBarPanel progressBar;
    private javax.swing.JCheckBox randomCheckBox;
    private org.thema.common.swing.SelectFilePanel selectFilePanelImportDataset;
    private javax.swing.JSpinner spinnerRatio;
    private org.jdesktop.beansbinding.BindingGroup bindingGroup;
    // End of variables declaration//GEN-END:variables
}
